
#include "Main.h"


//////////////////////////////////////////////////////////////////////////////
// globln promnn

TCHAR*		CommandLine = NULL;			// pkazov dek
DWORD		VersionOS = 0;				// verze systmu
HINSTANCE	hInstance = NULL;			// instance programu
MSG			msg;						// buffer pro pijet zprvy
int			ScreenWidth;				// ka klientsk oblasti displeje
int			ScreenHeight;				// vka klientsk oblasti displeje

CString		Jmeno;						// jmno editovanho souboru (bez cesty a ppony)
CString		Cesta;						// cesta k editovanmu souboru (s pp. "\" na konci)
CString		ExeFileName;				// jmno tohoto programu
CString		TextExe;					// text ".EXE"


//////////////////////////////////////////////////////////////////////////////
// seln konstanty

const double ln10 = 2.3025850929940456840;	// pirozen logaritmus 10


//////////////////////////////////////////////////////////////////////////////
// lokln promnn

#ifdef _MT
static	CRITICAL_SECTION	ExitCriticalSection;	// kritick sekce pro konec programu
#endif


//////////////////////////////////////////////////////////////////////////////
// hlavn start programu

void WinMainCRTStartup()
{
// schova adresy pkazovho dku
	CommandLine = ::GetCommandLine();

// schova verze systmu
	VersionOS = ::GetVersion();

// handle instance programu
	hInstance = ::GetModuleHandle(NULL);

// nastaven chybovho mdu
	::SetErrorMode(::SetErrorMode(0) | SEM_FAILCRITICALERRORS | SEM_NOOPENFILEERRORBOX 
				| SEM_NOGPFAULTERRORBOX | SEM_NOALIGNMENTFAULTEXCEPT);

// inicializace informac o displeji
	ScreenWidth = ::GetSystemMetrics(SM_CXFULLSCREEN);
	ScreenHeight = ::GetSystemMetrics(SM_CYFULLSCREEN);

// inicializace uzamykn ukonen programu
#ifdef _MT
	::InitializeCriticalSection(&ExitCriticalSection);
#endif

// inicializace sprvce pamti
	if (MemInit() == FALSE) 
	{
		Exit(255);
	}

// naten jmna programu
	Jmeno.Init();
	Cesta.Init();
	ExeFileName.Init();
	TCHAR buf[_MAX_PATH];
	buf[0] = 0;
	VERIFY(::GetModuleFileName(hInstance, buf, _MAX_PATH));
	ExeFileName = buf;
	TextExe.Init();
	TextExe = _T(".EXE");

// vytvoen hlavnho okna aplikace
	if (MainFrameCreate() == FALSE) 
	{
		Exit(252);
	}

// hlavn obslun smyka aplikace
	while (::GetMessage(&msg, NULL, 0, 0))
	{
		if (PreTranslateMessage(&msg) == FALSE)
		{
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}

// konec programu
	Exit(0);
};


//////////////////////////////////////////////////////////////////////////////
// ukonen programu

void Exit(int code)
{
// uzamknut ukonen programu
#ifdef _MT
	::EnterCriticalSection(&ExitCriticalSection);
#endif

// ukonen sprvce pamti
	MemTerm();

// uvolnn uzamykn ukonen programu
#ifdef _MT
	::DeleteCriticalSection(&ExitCriticalSection);
#endif

// ukonen programu
	ExitProcess(code);
}


//////////////////////////////////////////////////////////////////////////////
// vystedn okna proti jinmu oknu

void CenterWindow(HWND child, HWND parent)
{
	RECT rc1, rc2;

	if (parent == NULL)
	{
		::SystemParametersInfo(SPI_GETWORKAREA, NULL, &rc1, NULL);
	}
	else
	{
		::GetWindowRect(parent, &rc1);
	}
	::GetWindowRect(child, &rc2);

	::SetWindowPos(child, NULL, 
		(rc1.left + rc1.right)/2 - (rc2.right - rc2.left)/2,
		(rc1.top + rc1.bottom)/2 - (rc2.bottom - rc2.top)/2, 0, 0,
		SWP_NOOWNERZORDER | SWP_NOSIZE | SWP_NOZORDER);
}
