
//////////////////////////////////////////////////////////////////////////////
// pepnae preprocesoru:
//	_DEBUG ............. je debugger
//	_OPTIM ............. je optimalizace
//	_MT ................ vcevlknov reim
//
//	_M_IX86 ............ procesor Intel 86
//	_M_ALPHA ........... procesor DEC Alpha
//	_M_MPPC ............ procesor Power Macintosh
//	_M_MRX000 .......... procesor MIPS
//	_M_PPC ............. procesor PowerPC

//////////////////////////////////////////////////////////////////////////////
// obsluha debuggeru

#ifdef _DEBUG
#ifdef _M_IX86
#define debugbreak _asm{int 3}
#else	// _M_IX86
#define debugbreak DebugBreak()
#endif	// _M_IX86
#endif	// _DEBUG

#ifdef _DEBUG
#define ASSERT(f)			{ if ((f) == FALSE) debugbreak; }
#define VERIFY(f)			ASSERT(f)
#else	// _DEBUG
#define ASSERT(f)			((void)0)
#define VERIFY(f)			((void)(f))
#endif	// _DEBUG


//////////////////////////////////////////////////////////////////////////////
// standardn vnoen sekce

#include <windows.h>					// zkladn definice WINDOWS
#include <math.h>						// matematick operace
#include <alphaops.h>					// matematick konstanty
#include <tchar.h>						// obsluha znak UNICODE/MB
#include <commctrl.h>					// doplkov ovldac prvky
#include "resource.h"

//////////////////////////////////////////////////////////////////////////////
// peddefinice td

class CString;

//////////////////////////////////////////////////////////////////////////////
// globln promnn a funkce

extern	TCHAR*		CommandLine;		// pkazov dek
extern	DWORD		VersionOS;			// verze systmu
extern	HINSTANCE	hInstance;			// instance programu
extern	int			ScreenWidth;		// ka klientsk oblasti displeje
extern	int			ScreenHeight;		// vka klientsk oblasti displeje

extern	CString		Jmeno;				// jmno editovanho souboru (bez cesty a ppony)
extern	CString		Cesta;				// cesta k editovanmu souboru (s pp. "\" na konci)
extern	CString		ExeFileName;		// jmno programu
extern	CString		TextExe;			// text ".EXE"


//////////////////////////////////////////////////////////////////////////////
// ukonen aplikace

void	Exit(int code);					// ukonen programu


//////////////////////////////////////////////////////////////////////////////
// vystedn okna proti jinmu oknu

void CenterWindow(HWND child, HWND parent = NULL);


//////////////////////////////////////////////////////////////////////////////
// seln konstanty

extern	const	double	ln10;			// pirozen logaritmus 10

//////////////////////////////////////////////////////////////////////////////
// vlastn vnoen sekce

#include "Memory.h"						// obsluha pamti
#include "String.h"						// textov etzce
#include "MainFrm.h"					// hlavn okno aplikace
#include "Select.h"						// vbr souboru k editaci
#include "Prog.h"						// obsluha editace souboru
