
#include "Main.h"

/***************************************************************************\
*																			*
*							Hlavn okno aplikace							*
*																			*
\***************************************************************************/


/////////////////////////////////////////////////////////////////////////////
// globln a lokln promnn

TCHAR		MainFrameClass[] = _T("PeterMainFrameClass");	// nzev tdy hlavnho okna

HWND		MainFrame = NULL;						// hlavn okno aplikace
HMENU		Menu = NULL;							// aktivn menu
HWND		ToolBar = NULL;							// nstrojov lita
HWND		StatusBar = NULL;						// stavov lita

RECT		ClientRect;								// klientsk oblast hlavnho okna
int			ClientWidth;							// ka klientsk oblasti
int			ClientHeight;							// vka klientsk oblasti

CString		MainFrameName;							// titulek hlavnho okna - jmno aplikace
CString		MainFrameText;							// pln text titulku hlavnho okna
CString		StatusText;								// zobrazen text stavov lity

LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);
void InitClientRect();								// aktualizace klientskch souadnic

/////////////////////////////////////////////////////////////////////////////
// vytvoen hlavnho okna aplikace

BOOL MainFrameCreate()
{
// inicializace globlnch objekt
	MainFrameName.Init();
	MainFrameText.Init();
	SelectNewText.Init();
	StatusText.Init();

// zajitn knihovny rozench ovldacch prvk
	::InitCommonControls();

// registrace tdy okna
	WNDCLASS wcl;
	wcl.style = CS_DBLCLKS;
	wcl.lpfnWndProc = WindowProc;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hInstance = hInstance;
	wcl.hIcon = ::LoadIcon(hInstance, MAKEINTRESOURCE(IDN_MAINFRAME));
	wcl.hCursor = ::LoadCursor(NULL, IDC_ARROW);
	wcl.hbrBackground = NULL;
	wcl.lpszMenuName = MAKEINTRESOURCE(IDN_SELECT);
	wcl.lpszClassName = MainFrameClass;
	::RegisterClass(&wcl);

// naten titulku hlavnho okna
	MainFrameName.Load(IDN_MAINFRAME);
	MainFrameText = MainFrameName;

// vytvoen hlavnho okna
	MainFrame = ::CreateWindowEx(
		WS_EX_ACCEPTFILES | WS_EX_APPWINDOW | WS_EX_CONTEXTHELP 
			| WS_EX_CONTROLPARENT | WS_EX_WINDOWEDGE,	// rozen styl
		MainFrameClass,									// jmno tdy okna
		MainFrameName,									// titulek okna
		WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN 
			| WS_MAXIMIZEBOX | WS_MINIMIZEBOX 
			| WS_OVERLAPPED | WS_SYSMENU 
			| WS_THICKFRAME | WS_VISIBLE,				// styl okna
		ScreenWidth/10,									// X
		ScreenHeight/10,								// Y
		ScreenWidth*4/5,								// ka
		ScreenHeight*4/5,								// vka
		NULL,											// rodi
		NULL,											// menu
		hInstance,										// instance
		NULL);											// parametry
	if (MainFrame == NULL) return FALSE;

// vytvoen nstrojov lity
	ToolBar = ::CreateToolbarEx(
		MainFrame,										// rodi okna
		WS_CHILD | WS_BORDER | WS_VISIBLE | TBSTYLE_TOOLTIPS,	// styl okna
		IDN_TOOLBAR,									// identifiktor
		ToolButtonNum,									// poet tlatek v bitmap
		hInstance,										// instance
		IDN_TOOLBAR,									// ID obrzk tlatek
		NULL,											// definice tlatek
		0,												// poet tlatek k pidn
		16,												// ka bitmapy tlatek
		15,												// vka bitmapy tlatek
		24,												// ka tlatek (ignoruje)
		22,												// vka tlatek (ignoruje)
		sizeof(TBBUTTON));								// velikost definice tlatka
	::SendMessage(ToolBar, TB_SETBITMAPSIZE, 0, MAKELONG(16, 15));
	::SendMessage(ToolBar, TB_SETBUTTONSIZE, 0, MAKELONG(24, 22));

// vytvoen stavov lity (viz t CreateStatusWindow)
	StatusBar = ::CreateWindowEx(
		0,
		STATUSCLASSNAME,
		NULL,
		WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
		0,
		0,
		0,
		0,
		MainFrame,
		(HMENU)IDN_STATUS,
		hInstance,
		NULL);

// aktualizace klientsk oblasti
	InitClientRect();

// zahjen reimu vbru soubor
	SelectInit();
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace klientskch souadnic

void InitClientRect()
{
// naten souadnic klientsk oblasti okna
	::GetClientRect(MainFrame, &ClientRect);

// uren hornho okraje klientsk oblasti
	RECT rc;
	::GetWindowRect(ToolBar, &rc);
	ClientRect.top += rc.bottom - rc.top - 1;

// uren dolnho okraje klientsk oblasti
	::GetWindowRect(StatusBar, &rc);
	ClientRect.bottom -= rc.bottom - rc.top;

// uren vky a ky klientsk oblasti
	ClientWidth = ClientRect.right - ClientRect.left;
	ClientHeight = ClientRect.bottom - ClientRect.top;
}


/////////////////////////////////////////////////////////////////////////////
// zruen vech tlatek panelu nstroj

void ToolBarClear(int min)
{
	int i = ::SendMessage(ToolBar, TB_BUTTONCOUNT, 0, 0)-1;
	for (; i >= min; i--)
	{
		::SendMessage(ToolBar, TB_DELETEBUTTON, i, 0);
	}
}


/////////////////////////////////////////////////////////////////////////////
// pidn tlatek do panelu nstroj

void ToolBarAdd(TBBUTTON* button, int num)
{
	::SendMessage(ToolBar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
	::SendMessage(ToolBar, TB_ADDBUTTONS, num, (LPARAM)button);
}


/////////////////////////////////////////////////////////////////////////////
// nastaven novho menu

void SetNewMenu(int id)
{
	HMENU menu = ::LoadMenu(hInstance, MAKEINTRESOURCE(id));
	::SetMenu(MainFrame, menu);
	::DestroyMenu(Menu);
	Menu = menu;
}


/////////////////////////////////////////////////////////////////////////////
// vytvoen editanho pole v panelu nstroj

HWND CreateToolEdit(HWND toolbar, int id, int prevID, int nextID)
{
// naten souadnice pedchzejcho prvku
	RECT prev;
	int i = ::SendMessage(toolbar, TB_COMMANDTOINDEX, prevID, 0);
	::SendMessage(toolbar, TB_GETITEMRECT, i, (LPARAM)&prev);

// naten souadnice nsledujcho prvku
	RECT next;
	i = ::SendMessage(toolbar, TB_COMMANDTOINDEX, nextID, 0);
	::SendMessage(toolbar, TB_GETITEMRECT, i, (LPARAM)&next);

// pprava souadnic editanho pole
	RECT rc;
	rc.left = prev.right + 5;
	rc.top = prev.top + 1;
	rc.right = next.left;
	rc.bottom = next.bottom - 1;

// vytvoen editanho pole
	HWND edit = ::CreateWindowEx(
		WS_EX_CLIENTEDGE,
		_T("EDIT"),
		NULL, 
		WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP | ES_AUTOHSCROLL,
		rc.left,				// X
		rc.top,					// Y
		rc.right - rc.left,		// ka
		rc.bottom - rc.top,		// vka
		toolbar,				// rodi
		(HMENU)id,				// identifikace
		hInstance,
		NULL);

// nastaven fontu zobrazenho textu
	HFONT font = (HFONT)::GetStockObject(DEFAULT_GUI_FONT);
	if (font == NULL) font = (HFONT)::GetStockObject(ANSI_VAR_FONT);
	::SendMessage(edit, WM_SETFONT, (WPARAM)font, FALSE);

	return edit;
}


/////////////////////////////////////////////////////////////////////////////
// nastaven textu stavov lity

void SetStatusText(CString& text)
{
	if (text != StatusText)
	{
		::SendMessage(StatusBar, SB_SETTEXT, 0, (LPARAM)(LPCTSTR)text);
		StatusText = text;
	}
}


/////////////////////////////////////////////////////////////////////////////
// zobrazen jmna souboru v titulku okna

void ZobrazJmeno()
{
	CString text;

	if (Jmeno.IsNotEmpty())							// je njak jmno souboru ?
	{
		text = Cesta;								// ped jmnem souboru bude cesta

		if (Jmeno[0] == ' ')						// je to adres ?
		{
			text += Jmeno.Right(Jmeno.Length()-1);	// pidn jmna adrese
		}
		else
		{
			text += Jmeno;							// pidn jmna souboru
		}

		text += _T(" - ");							// oddlova
	}

	text += MainFrameName;							// pidn jmna aplikace

	if (text != MainFrameText)						// mn se titulek ?
	{
		MainFrameText = text;						// schova novho titulku
		::SetWindowText(MainFrame, text);			// nastaven novho titulku
	}
}


/////////////////////////////////////////////////////////////////////////////
// povolen volby v menu a v panelu nstroj

void EnableCommand(int id, BOOL enable)
{
// povolen tlatka nstrojovho panelu
	::SendMessage(ToolBar, TB_ENABLEBUTTON, id, enable);

// povolen volby menu
	::EnableMenuItem(Menu, id, MF_BYCOMMAND | enable ? (MF_ENABLED) : (MF_DISABLED | MF_GRAYED));
}


/////////////////////////////////////////////////////////////////////////////
// zobrazen informanho okna About

BOOL CALLBACK AboutBoxProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch (nMsg)
	{
	case WM_INITDIALOG:
		CenterWindow(hWnd, MainFrame);
		return TRUE;

	case WM_COMMAND:
		switch (HIWORD(wParam))
		{
		case 0:
		case 1:
			switch (LOWORD(wParam))
			{
			case IDOK:
			case IDCANCEL:
				::EndDialog(hWnd, LOWORD(wParam));
				return TRUE;
			}
			break;
		}
		break;
	}
	return FALSE;
}

void OnAboutBox()
{
	::DialogBoxParam(
		hInstance,
		MAKEINTRESOURCE(IDN_ABOUTBOX),
		MainFrame,
		(DLGPROC)AboutBoxProc,
		(LPARAM)0);
}

/////////////////////////////////////////////////////////////////////////////
// obsluha zprvy ped rozeslnm do oken

BOOL PreTranslateMessage(MSG* msg)
{
	HWND hWnd = msg->hwnd;
	WPARAM wParam = msg->wParam;
	LPARAM lParam = msg->lParam;

	switch (msg->message)
	{
	case WM_MOUSEMOVE:
		{
			POINT pt;
			pt.x = LOWORD(lParam);
			pt.y = HIWORD(lParam);

			CString txt;

			if (hWnd == ToolBar)
			{
				int item = 0;
				RECT rc;
				TBBUTTON but;

				for (;;)
				{
					if (::SendMessage(ToolBar, TB_GETITEMRECT, item, (LPARAM)&rc) == FALSE)
						break;

					if ((pt.x >= rc.left) && (pt.x < rc.right))
					{
						::SendMessage(ToolBar, TB_GETBUTTON, item, (LPARAM)&but);
						txt.Load(but.idCommand);

						int pos = txt.Find('\n');
						if (pos >= 0)
						{
							txt = txt.Left(pos);
						}
						break;
					}
					item++;
				}
			}
			SetStatusText(txt);
		}
		break;
	}

	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// obsluha zprv okna

LRESULT CALLBACK WindowProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch (nMsg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;

	case WM_PAINT:
		PAINTSTRUCT paint;
		::BeginPaint(hWnd, &paint);
		::EndPaint(hWnd, &paint);
		break;

	case WM_SIZE:
		::SendMessage(StatusBar, WM_SIZE, wParam, lParam); 
		::SendMessage(ToolBar, WM_SIZE, wParam, lParam); 
		InitClientRect();
		SelectOnSize();
		ProgOnSize();
		return 0;

	case WM_NOTIFY:
	  {
		NMHDR* nmhdr = ((NMHDR*)lParam);
		switch (nmhdr->code)
		{
		case TTN_NEEDTEXT:
		  {
			TOOLTIPTEXT* tip = (TOOLTIPTEXT*)lParam;
			CString txt;
			txt.Load(tip->hdr.idFrom);
			tip->szText[0] = 0;

			int pos = txt.Find('\n');
			if (pos >= 0)
			{
				MemCopy(tip->szText, (LPCTSTR)txt+pos+1, txt.Length() - pos);
			}
			tip->hinst = NULL;
			return 0;
		  }
		case LVN_ITEMCHANGED:
			SelectOnChange(nmhdr->hwndFrom, (NM_LISTVIEW*)lParam);
			return 0;

		case NM_DBLCLK:
			SelectOnDblClk(nmhdr->hwndFrom);
			return 0;

		case NM_RETURN:
			SelectOnDblClk(nmhdr->hwndFrom);
			return 0;
		}
		break;
	  }

	case WM_COMMAND:
		switch (HIWORD(wParam))
		{
		case 0:
		case 1:
			switch (LOWORD(wParam))
			{
			case IDN_OPEN:
				SelectOnOpen();
				return 0;

			case IDN_CLOSE:
				ProgTerm();
				SelectInit();
				return 0;

			case IDN_START:
				SelectOnStart();
				return 0;

			case IDN_EXIT:
				PostQuitMessage(0);
				return 0;

			case IDN_NEW:
				SelectOnNew();
				return 0;

			case IDN_NEWCOPY:
				SelectOnNewCopy();
				return 0;

			case IDN_PATH:
				SelectOnPath();
				return 0;

			case IDN_DELETE:
				SelectOnDelete();
				return 0;

			case IDN_ABOUT:
				OnAboutBox();
				return 0;
			}
			break;
		}
		break;

	case WM_SETFOCUS:
		SelectSetFocus();
		ProgSetFocus();
		return 0;

	case WM_MENUSELECT:
		if (LOWORD(wParam) != 0)
		{
			CString txt;
			txt.Load(LOWORD(wParam));
			int pos = txt.Find('\n');
			if (pos >= 0)
			{
				txt = txt.Left(pos);
			}
			SetStatusText(txt);
		}
		return 0;

	}

	return DefWindowProc(hWnd, nMsg, wParam, lParam);
}
