
/***************************************************************************\
*																			*
*								Obsluha pamti								*
*																			*
\***************************************************************************/


/////////////////////////////////////////////////////////////////////////////
// inicializace sprvce pamti

BOOL MemInit();


/////////////////////////////////////////////////////////////////////////////
// ukonen sprvce pamti

void MemTerm();


/////////////////////////////////////////////////////////////////////////////
// pidlen bloku pamti (povolena 0) (NULL=chyba)

void* MemGet(int size);


/////////////////////////////////////////////////////////////////////////////
// uvolnn bloku pamti (povoleno NULL)

void MemFree(void* adr);


/////////////////////////////////////////////////////////////////////////////
// zmna velikosti bloku pamti (povolena adresa NULL i velikost 0)

void* MemSize(void* adr, int size);


/////////////////////////////////////////////////////////////////////////////
// zmna velikosti bufferu prvk (zadv se reference na ukazatel a poet prvk)

#define MemBuf(adr, items)	*((void**)&adr) = MemSize((void*)adr, (items) * sizeof(adr[0]))


/////////////////////////////////////////////////////////////////////////////
// opertor new

inline void* operator new (unsigned int size)
{
	return MemGet(size);
}


/////////////////////////////////////////////////////////////////////////////
// opertor delete

inline void operator delete (void* adr)
{
	MemFree(adr);
}


/////////////////////////////////////////////////////////////////////////////
// naplnn bloku pamti konstantou

inline void MemFill(void* dst, int count, char val = 0)
{
#ifdef _OPTIM
	memset(dst, val, count);
#else
	for (; count > 0; count--)
	{
		*(char*)dst = val;
		dst = (char*)dst + 1;
	}
#endif
}


/////////////////////////////////////////////////////////////////////////////
// kopie bloku dat

inline void MemCopy(void* dst, const void* src, int count)
{
#ifdef _OPTIM
	memcpy(dst, src, count);
#else
	for (; count > 0; count--)
	{
		*(char*)dst = *(char*)src;
		dst = (char*)dst + 1;
		src = (char*)src + 1;
	}
#endif
}	


/////////////////////////////////////////////////////////////////////////////
// pesun bloku dat

inline void MemMove(void* dst, const void* src, int count)
{
	if ((dst <= src) || ((char*)dst >= ((char*)src + count)))
	{
#ifdef _OPTIM
		memcpy(dst, src, count);
#else
		for (; count > 0; count--)
		{
			*(char*)dst = *(char*)src;
			dst = (char*)dst + 1;
			src = (char*)src + 1;
		}
#endif
	}
	else
	{
		dst = (char*)dst + count - 1;
		src = (char*)src + count - 1;

		for (; count > 0; count--)
		{
			*(char*)dst = *(char*)src;
			dst = (char*)dst - 1;
			src = (char*)src - 1;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// porovnn bloku dat (TRUE=shoda)

inline BOOL MemCompare(const void* buf1, const void* buf2, int count)
{
#ifdef _OPTIM
	return memcmp(buf1, buf2, count) == 0;
#else
	for (; ((count > 0) && (*(char*)buf1 == *(char*)buf2)); count--)
	{
		buf1 = (char*)buf1 + 1;
		buf2 = (char*)buf2 + 1;
	}
	return (count == 0);
#endif
}
