
#include "Main.h"

/***************************************************************************\
*																			*
*							Vbr souboru k editaci							*
*																			*
\***************************************************************************/


/////////////////////////////////////////////////////////////////////////////
// globln a lokln promnn

BOOL		SelectMode = FALSE;						// pznak mdu vbru soubor
HWND		SelectView = NULL;						// seznam soubor
HIMAGELIST	SelectImageList = NULL;					// seznam obrzk

CString		SelectNewText;							// zadan jmno novho programu
BOOL		SelectNewFill = FALSE;					// pln se editor jmna novho programu
HWND		SelectNewEdit = NULL;					// handle editoru jmna novho programu


/////////////////////////////////////////////////////////////////////////////
// definice tlatek pro toolbar Select

TBBUTTON ToolBarSelect[] = {
	{ ButtonStart,	IDN_START,	TBSTATE_ENABLED, TBSTYLE_BUTTON,	0, 0},
	{ ButtonNew,	IDN_NEW,	TBSTATE_ENABLED, TBSTYLE_BUTTON,	0, 0},
	{ ButtonOpen,	IDN_OPEN,	TBSTATE_ENABLED, TBSTYLE_BUTTON,	0, 0},
};

#define ToolBarSelectNum (sizeof(ToolBarSelect)/sizeof(TBBUTTON))

void SelectLoad();				// naten seznamu soubor

/////////////////////////////////////////////////////////////////////////////
// zhlav novho programu

const struct { 
	char ident[3];			// (3) identifikace = "PET"
	BYTE verze;				// (1) verze = 1
	long param;				// (4) parametry = 0
	long data;				// (4) offset zatku dat od zatku zhlav (= dlka zhlav)
	long pocet;				// (4) poet datovch blok
} NewHead =
{
	'P', 'E', 'T',			// (3) identifikace = "PET"
	0,						// (1) verze = 1
	0,						// (4) parametry = 0
	3 + 1 + 4 + 4 + 4,		// (4) offset zatku dat od zatku zhlav (= dlka zhlav)
	0,						// (4) poet datovch blok
};


/////////////////////////////////////////////////////////////////////////////
// zahjen reimu vbru souboru k editaci

void SelectInit()
{
// kontrola, zda nen reim vbru souboru
	if (SelectMode) return;			// je ji reim vbru soubor
	SelectMode = TRUE;

// nastaven tlatek pro reim vbru
	ToolBarAdd(ToolBarSelect, ToolBarSelectNum); // pidn tlatek

// nastaven novho menu
	SetNewMenu(IDN_SELECT);

// vytvoen seznamu soubor
	SelectView = ::CreateWindowEx(
		WS_EX_CLIENTEDGE,
		WC_LISTVIEW,
		NULL,
		WS_VISIBLE | WS_CHILD | LVS_ICON | LVS_ALIGNTOP | LVS_SINGLESEL 
			| LVS_SORTASCENDING | LVS_SHAREIMAGELISTS | LVS_SHOWSELALWAYS,
		ClientRect.left,
		ClientRect.top,
		ClientWidth,
		ClientHeight,
		MainFrame,
		(HMENU)IDN_SELECT,
		hInstance,
		NULL);
	ASSERT(SelectView);

// vytvoen seznamu obrzk a pipojen k seznamu
	SelectImageList = ::ImageList_Create(32, 32, ILC_COLORDDB | ILC_MASK, 20, 20);
	ASSERT(SelectImageList);
	::SendMessage(SelectView, LVM_SETIMAGELIST, LVSIL_NORMAL, (LPARAM)SelectImageList);

// naten seznamu soubor
	SelectLoad();

// nastaven fokusu na aktivni okno
	SelectSetFocus();
}


/////////////////////////////////////////////////////////////////////////////
// ukonen reimu vbru souboru

void SelectTerm()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;
	SelectMode = FALSE;

// zruen okna pro vbr soubor
	::DestroyWindow(SelectView);

// zruen seznamu obrzk
	::ImageList_Destroy(SelectImageList);

// zruen vech tlatek v panelu nstroj
	ToolBarClear(0);
}


/////////////////////////////////////////////////////////////////////////////
// nastaven fokusu na okno vbru

void SelectSetFocus()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// nastaven fokusu na okno
	::SetFocus(SelectView);
}


/////////////////////////////////////////////////////////////////////////////
// zmna velikosti okna (WM_SIZE)

void SelectOnSize()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// zmna velikosti okna vbru
	::MoveWindow(SelectView, ClientRect.left, ClientRect.top, ClientWidth, ClientHeight, TRUE);

// pearanovn ikon v seznamu
	::SendMessage(SelectView, LVM_ARRANGE, LVA_ALIGNTOP, 0);
}


/////////////////////////////////////////////////////////////////////////////
// naten textu prvku seznamu

CString SelectGetItemText(int index)
{
	TCHAR buff[_MAX_PATH];

	LV_ITEM lvi;
	lvi.iSubItem = 0;
	lvi.pszText = buff;
	lvi.cchTextMax = _MAX_PATH;

	int num = ::SendMessage(SelectView, LVM_GETITEMTEXT, index, (LPARAM) &lvi);

	return CString(buff, num);
}


/////////////////////////////////////////////////////////////////////////////
// naten seznamu soubor

void SelectLoad()
{
// normalizace cesty - oezn mezer a "\" ze zatku a konce
	Cesta.TrimLeft();
	Cesta.TrimRight();
	while (Cesta.Get(0) == '\\')
	{
		Cesta.Delete(0,1);
	}
	while (Cesta.IsNotEmpty() && (Cesta[Cesta.Length()-1] == '\\'))
	{
		Cesta.Delete(Cesta.Length()-1);
	}

// zjitn platnosti cesty
	BOOL ok = FALSE;
	int attrib;
	while ((ok == FALSE) && Cesta.IsNotEmpty())
	{
		attrib = (int)::GetFileAttributes(Cesta);
		if ((attrib != -1) &&
			((attrib & FILE_ATTRIBUTE_DIRECTORY) != 0) &&
			((attrib & FILE_ATTRIBUTE_HIDDEN) == 0))
		{
			ok = TRUE;
		}
		else
		{
			Cesta.Delete(Cesta.RevFind('\\'));
		}
	}

// zajitn znaku "\" na konci cesty
	if (Cesta.IsNotEmpty()) Cesta += '\\';

// zruen vech poloek v seznamu
	::SendMessage(SelectView, LVM_DELETEALLITEMS, 0, 0);

// vyprzdnn seznamu obrzk
	HIMAGELIST oldimagelist = SelectImageList;
	SelectImageList = ::ImageList_Create(32, 32, ILC_COLORDDB | ILC_MASK, 20, 20);
	ASSERT(SelectImageList);
	::SendMessage(SelectView, LVM_SETIMAGELIST, LVSIL_NORMAL, (LPARAM)SelectImageList);
	::ImageList_Destroy(oldimagelist);

// promnn pro naten seznamu
	WIN32_FIND_DATA wfd;			// struktura pro hledn soubor
	HANDLE handle;					// handle hledn soubor
	CString jmeno;					// jmno nalezenho souboru
	LV_ITEM lvi;					// vkldan poloka do seznamu
	int poz;						// pozice desetinn teky ve jmnu souboru
	int items = 0;					// ta poloek v seznamu
	HICON icon;						// handle ikony ze souboru
	HANDLE file;					// handle nalezenho souboru
	char* buff = (char*)MemGet(0x1000);	// buffer pro naten souboru
	DWORD read;						// poet natench bajt ze souboru
	int off;						// offset v bufferu souboru

// naten ikon pro adrese
	icon = ::LoadIcon(hInstance, MAKEINTRESOURCE(IDN_DIR));
	ASSERT(icon);
	::ImageList_ReplaceIcon(SelectImageList, -1, icon);
	icon = ::LoadIcon(hInstance, MAKEINTRESOURCE(IDN_DIR2));
	ASSERT(icon);
	::ImageList_ReplaceIcon(SelectImageList, -1, icon);

// pprava poloky seznamu
	lvi.mask = LVIF_TEXT | LVIF_IMAGE;
	lvi.iSubItem = 0;

// doplnn poloky "..", je-li podadres
	if (Cesta.IsNotEmpty())
	{
		lvi.iItem = items;
		lvi.pszText = _T(" ..");
		lvi.iImage = 1;
		::SendMessage(SelectView, LVM_INSERTITEM, 0, (LPARAM)&lvi);
		items++;
	}

// naten vech podadres
	handle = ::FindFirstFile(Cesta + _T("*.*"), &wfd);
	if (handle != INVALID_HANDLE_VALUE)
	{
		do
		{
			if (((wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0) &&
				((wfd.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) == 0))
			{
				jmeno = wfd.cFileName;

				if ((jmeno != _T(".")) && (jmeno != _T("..")))
				{
					jmeno = ' ' + jmeno;
					lvi.iItem = items;
					lvi.pszText = (LPTSTR)(LPCTSTR)jmeno;
					lvi.iImage = 0;
					::SendMessage(SelectView, LVM_INSERTITEM, 0, (LPARAM)&lvi);
					items++;
				}
			}
			
		} while (::FindNextFile(handle, &wfd));
		::FindClose(handle);
	}

// vyhledn soubor
	handle = ::FindFirstFile(Cesta + _T("*.exe"), &wfd);
	if (handle != INVALID_HANDLE_VALUE)
	{
		do
		{

// oteven souboru
			jmeno = wfd.cFileName;
			file = ::CreateFile(Cesta + jmeno, GENERIC_READ, FILE_SHARE_READ, NULL,
				OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

			if (file != INVALID_HANDLE_VALUE)
			{

// naten zatku souboru
				::ReadFile(file, buff, 0x300, &read, NULL);
				::SetFilePointer(file, 0, NULL, FILE_BEGIN);

// kontrola, zda je to soubor EXE
				if ((read == 0x300) &&
					(buff[0] == 'M') &&
					(buff[1] == 'Z'))
				{

// nalezen popisu relokan tabulky
					off = 0x178;
					while	((off < 0x178 + 12*0x28) && (
							(buff[off+0] != '.') ||
							(buff[off+1] != 'r') ||
							(buff[off+2] != 'e') ||
							(buff[off+3] != 'l') ||
							(buff[off+4] != 'o') ||
							(buff[off+5] != 'c')))
					{
						off += 0x28;
					}

// nastaven ukazatele na ppadn zatek zhlav PET
					if	(	(buff[off+0] == '.') &&
							(buff[off+1] == 'r') &&
							(buff[off+2] == 'e') &&
							(buff[off+3] == 'l') &&
							(buff[off+4] == 'o') &&
							(buff[off+5] == 'c'))
					{
						::SetFilePointer(file, *(int*)(&buff[off+0x10]) +
								*(int*)(&buff[off+0x14]), NULL, FILE_BEGIN);
					}
				}

// naten zhlav ppadnho PET
				::ReadFile(file, buff, 0x1000, &read, NULL);

// uzaven souboru
				::CloseHandle(file);

// kontrola, zda je to zhlav PET
				if ((read >= sizeof(NewHead)) &&
					(buff[0] == 'P') &&
					(buff[1] == 'E') &&
					(buff[2] == 'T') &&
					(buff[3] < 10) &&
					(*(DWORD*)(&buff[12]) < 20))
				{

// naten ikony ze souboru
					icon = ::ExtractIcon(hInstance, Cesta + jmeno, 0);

					if ((int)icon <= 1)
					{
						icon = ::LoadIcon(hInstance, MAKEINTRESOURCE(IDN_MAINFRAME));
					}

// pidn poloky do seznamu
					if ((int)icon > 1)
					{
						poz = jmeno.RevFind('.');
						if (poz >= 0)
						{
							jmeno.Delete(poz);
						}

						lvi.iItem = items;
						lvi.pszText = (LPTSTR)(LPCTSTR)jmeno;
						lvi.iImage = ::ImageList_ReplaceIcon(SelectImageList, -1, icon);
						::SendMessage(SelectView, LVM_INSERTITEM, 0, (LPARAM)&lvi);
						items++;
					}				
				}
			}

// nalezen dalho souboru
		} while (::FindNextFile(handle, &wfd));
		::FindClose(handle);
	}

// uvolnn bufferu pro ten souboru
	MemFree(buff);

// pednastaven na prvn jmno, nen-li dn jmno pednastaveno
	if (Jmeno.IsEmpty() && ((int)::SendMessage(SelectView, LVM_GETITEMCOUNT, 0, 0) > 0))
	{
		Jmeno = SelectGetItemText(0);
	}

// nalezen poloky se zadanm jmnem
	LV_FINDINFO lvf;
	if (Jmeno.IsNotEmpty())
	{
		lvf.flags = LVFI_STRING;
		lvf.psz = Jmeno;
		int i = ::SendMessage(SelectView, LVM_FINDITEM, (WPARAM)-1, (LPARAM)&lvf);

// pi nenalezen poloky pokus o nalezen adrese se zadanm jmnem
		if (i < 0)
		{
			CString x = ' ' + Jmeno;
			lvf.psz = x;
			i = ::SendMessage(SelectView, LVM_FINDITEM, (WPARAM)-1, (LPARAM)&lvf);
			if (i >= 0) Jmeno = x;
		}

// pi nespchu se pouije prvn jmno v seznamu
		if ((i < 0) && ((int)::SendMessage(SelectView, LVM_GETITEMCOUNT, 0, 0) > 0))
		{
			Jmeno = SelectGetItemText(0);
			lvf.psz = Jmeno;
			i = ::SendMessage(SelectView, LVM_FINDITEM, (WPARAM)-1, (LPARAM)&lvf);
		}

// pi nalezen poloky nastaven kurzoru na poloku
		if (i >= 0)
		{
			lvi.stateMask = LVIS_FOCUSED | LVIS_SELECTED;
			lvi.state = LVIS_FOCUSED | LVIS_SELECTED;
			::SendMessage(SelectView, LVM_SETITEMSTATE, i, (LPARAM) &lvi);
		}

// jinak zruen jmna
		else
		{
			Jmeno.Empty();
		}
	}

// aktualizace zobrazen jmna v titulku okna
	ZobrazJmeno();

// aktualizace tlatek a poloek menu
	UpdateStartOpen();
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace volby Start, Open, Kopie a Delete

void UpdateStartOpen()
{
	BOOL enable = TRUE;

// start, oteven, ruen, kopie - mus bt platn jmno pod kurzorem
	if (Jmeno.IsEmpty())
	{
		enable = FALSE;
	}
	EnableCommand(IDN_START, enable);
	EnableCommand(IDN_OPEN, enable);

// poloku ".." nelze ruit ani koprovat
	if (Jmeno == _T(" .."))
	{
		enable = FALSE;
	}
	EnableCommand(IDN_DELETE, enable);

// adres nelze koprovat
	if (Jmeno.Get(0) == ' ')
	{
		enable = FALSE;
	}
	EnableCommand(IDN_NEWCOPY, enable);
}


/////////////////////////////////////////////////////////////////////////////
// zmna aktuln poloky (LVN_ITEMCHANGED)

void SelectOnChange(HWND hWnd, NM_LISTVIEW* nmlv)
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// kontrola, zda je zprva od okna vbru
	if (hWnd != SelectView) return;

// kontrola platnosti poloky
	if (nmlv->iItem >= 0)
	{

// kontrola, zda je zmna zamen ze star poloky na novou
		if (((nmlv->uNewState & LVIS_FOCUSED) != 0) &&
			((nmlv->uOldState & LVIS_FOCUSED) == 0))
		{

// nastaven novho jmna souboru
			Jmeno = SelectGetItemText(nmlv->iItem);
			ZobrazJmeno();
		}
	}

// aktualizace tlatek a poloek menu
	UpdateStartOpen();
}


/////////////////////////////////////////////////////////////////////////////
// oteven souboru k editaci

void SelectOnOpen()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// pro adres se provede zmna adrese
	if (Jmeno.Get(0) == ' ')
	{
		SelectOnStart();
	}

// pro soubor oteven k editaci
	else
	{

// ukonen reimu vbru soubor
		SelectTerm();

// zahjen reimu editace soubor
		ProgInit();
	}
}


/////////////////////////////////////////////////////////////////////////////
// dvojklik my - start programu

void SelectOnDblClk(HWND hWnd)
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// kontrola, zda je zprva od okna vbru
	if (hWnd != SelectView) return;

// start aktivnho programu
	SelectOnStart();
}


/////////////////////////////////////////////////////////////////////////////
// start programu nebo zmna adrese

void SelectOnStart()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// pouze je-li njak jmno souboru
	if (Jmeno.IsNotEmpty())
	{

// kontrola, zda to je adres
		if (Jmeno[0] == ' ')
		{

// vynoen z adrese
			if (Jmeno == _T(" .."))
			{
				Cesta.Delete(Cesta.Length()-1);		// odstrann koncovho "\"
				int index = Cesta.RevFind('\\')+1;	// nalezen pedelho "\" nebo 0
				Jmeno = _T(" ") + Cesta.Right(Cesta.Length()-index); // posledn adres
				Cesta.Delete(index);				// odstrann poslednho adrese
			}
			else
			{
				Cesta += Jmeno.Right(Jmeno.Length()-1) + '\\'; // nov cesta
				Jmeno.Empty();
			}
			SelectLoad();							// znovunaten adrese
		}

// je to soubor - start programu
		else
		{
			STARTUPINFO si;
			MemFill(&si, sizeof(si));
			si.cb = sizeof(si);

			PROCESS_INFORMATION pi;
			MemFill(&pi, sizeof(pi));

			::CreateProcess(
				Cesta + Jmeno + TextExe,			// jmno programu
				NULL,								// pkazov dek
				NULL,								// ochrann atributy procesu
				NULL,								// ochrann atributy vlkna
				FALSE,								// ddinost handl
#ifdef _UNICODE
				CREATE_UNICODE_ENVIRONMENT			// parametry
#else
				0
#endif
				/*| HIGH_PRIORITY_CLASS */| DETACHED_PROCESS,
				NULL,								// prosted
				NULL,								// vchoz adres
				&si,								// adresa STARTUPINFO
				&pi);								// adresa PROCESS_INFORMATION

//			::WaitForSingleObject(pi.hProcess, INFINITE);	// ekn na ukonen procesu
//			DWORD exitcode;
//			::GetExitCodeProcess(pi.hProcess, &exitcode);		// zjitn nvratovho kdu

			::CloseHandle(pi.hProcess);				// uzaven handle procesu
			::CloseHandle(pi.hThread);				// uzaven handle toku
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// obsluha dialogu

BOOL CALLBACK SelectDialogProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch (nMsg)
	{
	case WM_INITDIALOG:
		CenterWindow(hWnd, MainFrame);
		SelectNewEdit = ::GetDlgItem(hWnd, IDN_SELECT_EDIT);
		::SetWindowText(SelectNewEdit, SelectNewText);
		return TRUE;

	case WM_COMMAND:
		switch (HIWORD(wParam))
		{
		case 0:
		case 1:
			switch (LOWORD(wParam))
			{
			case IDOK:
			case IDCANCEL:
				SelectNewText.GetWindowText(SelectNewEdit);
				::EndDialog(hWnd, LOWORD(wParam));
				return TRUE;
			}
			break;

		case EN_CHANGE:
			if (SelectNewFill == FALSE)
			{
				SelectNewFill = TRUE;
	
				int selstart;
				int selend;
				::SendMessage(SelectNewEdit, EM_GETSEL, (WPARAM)&selstart, (LPARAM)&selend);
				SelectNewText.GetWindowText(SelectNewEdit);
					
				for (int i = 0; i < SelectNewText.Length(); i++)
				{
					TCHAR znak = SelectNewText[i];
					if ((BYTE)znak < 32) znak = 0;
					switch(znak)
					{
					case 0:
					case '*':
					case '|':
					case '\\':
					case ':':
					case '"':
					case '<':
					case '>':
					case '?':
					case '/':
						SelectNewText.Delete(i,1);
						if (selstart > i) selstart--;
						if (selend > i) selend--;
						SelectNewText.SetWindowText(SelectNewEdit);
						::SendMessage(SelectNewEdit, EM_SETSEL, selstart, selend);
						i--;
					}
				}
				SelectNewFill = FALSE;
			}
			break;
		}
		break;

	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// vytvoen novho souboru

void SelectOnNew()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// pprava zadanho jmna souboru
	SelectNewText = Jmeno;
	SelectNewText.TrimLeft();
	if (SelectNewText == _T(".."))
	{
		SelectNewText.Empty();
	}

// cyklus opakovn zadn
	int dialogID = IDN_SELECT_NEW;

	for (;;)
	{

// zadn jmna programu
		if (::DialogBoxParam(
					hInstance,
					MAKEINTRESOURCE(dialogID),
					MainFrame,
					(DLGPROC)SelectDialogProc,
					(LPARAM)0) != IDOK) return;

// pednastaven ptho dialogu
		dialogID = IDN_SELECT_CREATE;

// korekce zadanho textu
		SelectNewText.TrimLeft();
		SelectNewText.TrimRight();
		if (SelectNewText.IsEmpty()) return;

// vytvoen souboru
		HANDLE file = ::CreateFile(Cesta + SelectNewText + TextExe, GENERIC_WRITE,
			0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);

// chyba vytvoen - test, zda soubor ji existuje (jinak hlena neznm chyba)
		if (file == INVALID_HANDLE_VALUE)
		{
			if ((int) :: GetFileAttributes(Cesta + SelectNewText + TextExe) != -1)
			{
				dialogID = IDN_SELECT_EXIST;
			}
		}

// zpis novho programu
		else
		{
			HRSRC	hRes;				// resource
			DWORD	loaderN;			// dlka dat zavade
			HGLOBAL	hData;				// handle pamti
			DWORD	writen;				// poet zapsanch dat

// nalezen resource zavade
			hRes = ::FindResource(hInstance, MAKEINTRESOURCE(IDN_LOADER), _T("LOADER"));
			ASSERT(hRes != NULL);
			if (hRes != NULL)
			{

// naten zavade do pamti
				loaderN = ::SizeofResource(hInstance, hRes);
				hData = ::LoadResource(hInstance, hRes);
				ASSERT((hData != NULL) && (loaderN > 100000));
				if ((hData != NULL) && (loaderN > 100000))
				{

// zpis zavade a przdnho programu
					::WriteFile(file, ::LockResource(hData), loaderN, &writen, NULL);
					ASSERT(writen == loaderN);
					::WriteFile(file, &NewHead, sizeof(NewHead), &writen, NULL);
					ASSERT(writen == sizeof(NewHead));
					::CloseHandle(file);

// nastaven novho jmna souboru
					Jmeno = SelectNewText;
					ZobrazJmeno();

// zahjen editace programu
					SelectOnOpen();
					return;
				}
			}
// uzaven souboru (a pokraovn chybovm hlenm)
			::CloseHandle(file);
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// vytvoen novho souboru kopi

void SelectOnNewCopy()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// kontrola, zda je platn jmno souboru pod kurzorem
	if (Jmeno.IsEmpty()) return;
	if (Jmeno.Get(0) == ' ') return;

// pprava zadanho jmna souboru
	SelectNewText = Jmeno;
	SelectNewText.TrimLeft();
	if (SelectNewText == _T(".."))
	{
		SelectNewText.Empty();
	}

// cyklus opakovn zadn
	int dialogID = IDN_SELECT_NEW;

	for (;;)
	{

// zadn jmna programu
		if (::DialogBoxParam(
					hInstance,
					MAKEINTRESOURCE(dialogID),
					MainFrame,
					(DLGPROC)SelectDialogProc,
					(LPARAM)0) != IDOK) return;

// pednastaven ptho dialogu
		dialogID = IDN_SELECT_EXIST;

// korekce zadanho textu
		SelectNewText.TrimLeft();
		SelectNewText.TrimRight();
		if (SelectNewText.IsEmpty()) return;

// kopie souboru
		if (::CopyFile(Cesta + Jmeno + TextExe, Cesta + SelectNewText + TextExe, TRUE))
		{

// nastaven novho jmna souboru
			Jmeno = SelectNewText;
			ZobrazJmeno();

// zahjen editace programu
			SelectOnOpen();
			return;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// vytvoen adrese

void SelectOnPath()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// pprava zadanho jmna souboru
	SelectNewText = Jmeno;
	SelectNewText.TrimLeft();
	if (SelectNewText == _T(".."))
	{
		SelectNewText.Empty();
	}

// zadn jmna adrese
	if (::DialogBoxParam(
				hInstance,
				MAKEINTRESOURCE(IDN_SELECT_DIR),
				MainFrame,
				(DLGPROC)SelectDialogProc,
				(LPARAM)0) != IDOK) return;

// korekce zadanho textu
	SelectNewText.TrimLeft();
	SelectNewText.TrimRight();
	if (SelectNewText.IsEmpty()) return;

// vytvoen adrese
	::CreateDirectory(Cesta + SelectNewText, NULL);

// nastaven novho jmna souboru
	Jmeno = ' ' + SelectNewText;
	ZobrazJmeno();

// znovunaten obsahu adrese
	SelectLoad();
}


/////////////////////////////////////////////////////////////////////////////
// zruen souboru nebo adrese

void SelectOnDelete()
{
// kontrola, zda je reim vbru
	if (SelectMode == FALSE) return;

// kontrola, zda je platn jmno
	if (Jmeno.IsEmpty()) return;
	if (Jmeno == _T(" ..")) return;

// zobrazen dialogu k potvrzen operace
	if (::DialogBoxParam(
				hInstance,
				MAKEINTRESOURCE(IDN_SELECT_DEL),
				MainFrame,
				(DLGPROC)SelectDialogProc,
				(LPARAM)0) != IDOK) return;

// nalezen indexu nsledujc poloky
	LV_FINDINFO find;
	find.flags = LVFI_STRING;
	find.psz = Jmeno;
	int index = ::SendMessage(SelectView, LVM_FINDITEM, (WPARAM)-1, (LPARAM) &find) + 1;
	if (index >= (int)::SendMessage(SelectView, LVM_GETITEMCOUNT, 0, 0)) index -= 2;

// zruen adrese
	if (Jmeno[0] == ' ')
	{
		if (::RemoveDirectory(Cesta + Jmeno.Right(Jmeno.Length()-1)) == FALSE) return;
	}

// zruen souboru
	else
	{
		if (::DeleteFile(Cesta + Jmeno + TextExe) == FALSE) return;
	}

	Jmeno = SelectGetItemText(index);
	ZobrazJmeno();
	SelectLoad();
}
