
#include "Main.h"

/***************************************************************************\
*																			*
*								Textov etzce								*
*																			*
\***************************************************************************/


/////////////////////////////////////////////////////////////////////////////
// inicializan przdn etzec (modifikuje se poet referenc!)

STRINGDATA	EmptyStringData		= { 1, 0, 0 };


/////////////////////////////////////////////////////////////////////////////
// destruktor

CString::~CString() 
{ 
	Detach(); 
};


/////////////////////////////////////////////////////////////////////////////
// konverzn konstruktory (-1 = implicitn poet znak)

CString::CString(LPCTSTR text, int length)
{
	int len = (text == NULL) ? 0 : ((length < 0) ? lstrlen(text) : length);
	NewBuffer(len);	
	MemCopy(pData->Data, text, len*sizeof(TCHAR));
}

#ifdef _UNICODE

CString::CString(LPCSTR text, int length)
{
	int len = (text == NULL) ? 0 : ((length < 0) ? lstrlenA(text) : length);
	NewBuffer(len);
	::MultiByteToWideChar(CP_ACP, 0, text, len, pData->Data, len+1);
}

#else //_UNICODE

CString::CString(LPCWSTR text, int length)
{
	int len = (text == NULL) ? 0 : ((length < 0) ? lstrlenW(text) : length);
	NewBuffer(len);
	::WideCharToMultiByte(CP_ACP, 0, text, len, pData->Data, len+1, NULL, NULL);
}

#endif //_UNICODE

CString::CString(TCHAR chr)
{
	NewBuffer(1);
	pData->Data[0] = chr;
}


/////////////////////////////////////////////////////////////////////////////
// manipulace s etzcem

// naten textu z resource
void CString::Load(int nID)
{
	TCHAR buf[300];
	buf[0] = 0;
	int len = ::LoadString(hInstance, nID, buf, 300);
	Detach();
	NewBuffer(len);	
	MemCopy(pData->Data, buf, len*sizeof(TCHAR));
}


// vyprzdnn etzce (s ppadnm zruenm bufferu)
void CString::Empty()
{ 
	Detach(); 
	Attach(&EmptyStringData); 
}


/////////////////////////////////////////////////////////////////////////////
// pravy textu

// nastaven znaku na pozici bez kontroly
//TCHAR& CString::operator[] (int index)
//{
//	ASSERT((DWORD)index < (DWORD)pData->Length);
//	CopyWrite();
//	return pData->Data[index];
//}

// poskytnut znaku na pozici s kontrolou
TCHAR CString::Get(int index) const
{ 
	if ((DWORD)index >= (DWORD)pData->Length)
	{
		return 0;
	}
	return pData->Data[index];
}

// nastaven znaku na pozici s kontrolou
void CString::Set(int index, TCHAR znak)
{
	if ((DWORD)index < (DWORD)pData->Length)
	{
		CopyWrite();
		pData->Data[index] = znak;
	}
}

// naten textu okna
void CString::GetWindowText(const HWND wnd)
{
	Detach();
	NewBuffer(::GetWindowTextLength(wnd));
	::GetWindowText(wnd, pData->Data, pData->Length+1);
}

// konverze na velk psmena
void CString::UpperCase()
{
	CopyWrite();
	::CharUpper(pData->Data);
}

// konverze na mal psmena
void CString::LowerCase()
{
	CopyWrite();
	::CharLower(pData->Data);
}

// lev vez textu
CString CString::Left(int count) const
{
	int len = pData->Length;

	if ((DWORD)count > (DWORD)len)
	{
		if (count < 0)
		{
			count = 0;
		}
		else
		{
			count = len;
		}
	}
	return CString(pData->Data, count);
}

// prav vez textu
CString CString::Right(int count) const
{
	int len = pData->Length;

	if ((DWORD)count > (DWORD)len)
	{
		if (count < 0)
		{
			count = 0;
		}
		else
		{
			count = len;
		}
	}
	return CString(pData->Data + len - count, count);
}

// stedn vez textu
CString CString::Mid(int first, int count) const
{
	int len = pData->Length;

	if ((DWORD)first > (DWORD)len)
	{
		if (first < 0)
		{
			first = 0;
		}
		else
		{
			first = len;
		}
	}

	if (count < 0) count = 0;
	if ((first + count) > len) count = len - first;
	
	return CString(pData->Data + first, count);
}

// zruen skupiny znak
void CString::Delete(int first, int count)
{
	int len = pData->Length;

	if ((DWORD)first > (DWORD)len)
	{
		if (first < 0)
		{
			first = 0;
		}
		else
		{
			first = len;
		}
	}

	if (count < 0) count = 0;
	if ((DWORD)(first + count) > (DWORD)len) count = len - first;

	if (count != 0)
	{
		CopyWrite();
		int firstcount = first + count;
		MemCopy(pData->Data + first, pData->Data + firstcount, len - firstcount + 1);
		pData->Length -= count;
	}
}


// odstrann mezer zprava
void CString::TrimRight()
{
	CopyWrite();					// pivlastnn bufferu

	int i = pData->Length;			// dlka textu
	TCHAR* data = pData->Data + i;	// adresa za koncem textu

	for (; i != 0; i--)				// pro vechny znaky textu
	{
		data--;						// posun adresy
#ifdef _UNICODE
		if ((WORD)*data > ' ') break;	// pro platn znak konec
#else
		if ((BYTE)*data > ' ') break;	// pro platn znak konec
#endif
	}

	pData->Length = i;				// nov dlka textu
	pData->Data[i] = 0;				// oznaen konce textu
}

void CString::TrimLeft()
{
	CopyWrite();					// pivlastnn bufferu

	TCHAR* data = pData->Data;		// ukazatel textu

#ifdef _UNICODE
	while ((*data != 0) && ((WORD)*data <= ' '))
#else
	while ((*data != 0) && ((BYTE)*data <= ' '))
#endif
	{
		data++;
	}

	int dif = data - pData->Data;

	if (dif != 0)
	{
		pData->Length -= dif;
		MemCopy(pData->Data, data, (pData->Length+1)*sizeof(TCHAR));
	}
}


/////////////////////////////////////////////////////////////////////////////
// opertor piazen

const CString& CString::operator= (const CString& src)
{
	Detach();				// zruen starch dat
	Attach(src.pData);		// piazen novch dat
	return *this;
}

const CString& CString::operator= (LPCTSTR text)
{
	int len = (text == NULL) ? 0 : lstrlen(text);
	Detach();
	NewBuffer(len);	
	MemCopy(pData->Data, text, len*sizeof(TCHAR));
	return *this;
}

#ifdef _UNICODE

const CString& CString::operator= (LPCSTR text)
{
	int len = (text == NULL) ? 0 : lstrlenA(text);
	Detach();
	NewBuffer(len);
	::MultiByteToWideChar(CP_ACP, 0, text, len, pData->Data, len+1);
	return *this;
}

#else //_UNICODE

const CString& CString::operator= (LPCWSTR text)
{
	int len = (text == NULL) ? 0 : lstrlenW(text);
	Detach();
	NewBuffer(len);
	::WideCharToMultiByte(CP_ACP, 0, text, len, pData->Data, len+1, NULL, NULL);
	return *this;
}

#endif //_UNICODE

const CString& CString::operator= (const TCHAR chr)
{
	Detach();
	NewBuffer(1);
	pData->Data[0] = chr;
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
// hledn

int CString::Find(const CString& src)
{
// hledan etzec przdn - bude pozice 0
	int lensrc = src.pData->Length;
	if (lensrc == 0) return 0;

// hledan etzec m dlku 1 - pevod na hledn znaku
	TCHAR* datasrc = src.pData->Data;
	TCHAR chr = datasrc[0];
	if (lensrc == 1) return Find(chr);

// pprava ukazatel
	int i = pData->Length - lensrc;		// poet testovanch pozic - 1
	datasrc++;							// druh znak hledanho etzce
	lensrc--;							// dlka hledanho etzce - 1
	TCHAR* data = pData->Data;			// zatek prohledvanho etzce

// cyklus hledn
	for (; i >= 0; i--)
	{
		if (*(data++) == chr)			// shoduje se prvn znak?
		{
			if (MemCompare(data, datasrc, lensrc*sizeof(TCHAR)))	// shoduje se zbytek etzce?
			{
				return (data - pData->Data - 1);	// nvrat pozice zatku etzce
			}
		}
	}

	return -1;
}

int CString::Find(LPCTSTR text)
{
// hledan etzec przdn - bude pozice 0
	int lensrc = (text == NULL) ? 0 : lstrlen(text);
	if (lensrc == 0) return 0;

// hledan etzec m dlku 1 - pevod na hledn znaku
	const TCHAR* datasrc = text;
	TCHAR chr = datasrc[0];
	if (lensrc == 1) return Find(chr);

// pprava ukazatel
	int i = pData->Length - lensrc;		// poet testovanch pozic - 1
	datasrc++;							// druh znak hledanho etzce
	lensrc--;							// dlka hledanho etzce - 1
	TCHAR* data = pData->Data;			// zatek prohledvanho etzce

// cyklus hledn
	for (; i >= 0; i--)
	{
		if (*(data++) == chr)			// shoduje se prvn znak?
		{
			if (MemCompare(data, datasrc, lensrc*sizeof(TCHAR)))	// shoduje se zbytek etzce?
			{
				return (data - pData->Data - 1);	// nvrat pozice zatku etzce
			}
		}
	}

	return -1;
}

int CString::Find(const TCHAR chr)
{
	TCHAR* data = pData->Data;
	while ((*data != 0) && (*data != chr))
	{
		data++;
	}

	if (*data == 0)
	{
		return -1;
	}
	
	return data - pData->Data;
}

int CString::RevFind(const TCHAR chr)
{
	int i = pData->Length;
	TCHAR* data = pData->Data + i;
	i--;

	for (; i >= 0; i--)
	{
		data--;
		if (*data == chr) break;
	}

	return i;
}


/////////////////////////////////////////////////////////////////////////////
// opertor piten

const CString& CString::operator+= (const CString& src)
{
	int len1 = pData->Length;
	int len2 = src.pData->Length;
	CopyWrite();			// pivlastnn bufferu
	SizeBuffer(len1+len2);	// zmna velikosti bufferu
	MemCopy(pData->Data + len1, src.pData->Data, len2*sizeof(TCHAR));
	return *this;
}

const CString& CString::operator+= (LPCTSTR text)
{
	int len1 = pData->Length;
	int len2 = (text == NULL) ? 0 : lstrlen(text);
	CopyWrite();			// pivlastnn bufferu
	SizeBuffer(len1+len2);	// zmna velikosti bufferu
	MemCopy(pData->Data + len1, text, len2*sizeof(TCHAR));
	return *this;
}

const CString& CString::operator+= (const TCHAR chr)
{
	int len1 = pData->Length;
	CopyWrite();			// pivlastnn bufferu
	SizeBuffer(len1+1);		// zmna velikosti bufferu
	pData->Data[len1] = chr;
	return *this;
}


//////////////////////////////////////////////////////////////////////////////
// opertory

CString operator+ (const CString& string1, const CString& string2)
{
	return CString(string1, string2);
}

CString operator+ (LPCTSTR string1, const CString& string2)
{
	return CString(string1, string2);
}

CString operator+ (const CString& string1, LPCTSTR string2)
{
	return CString(string1, string2);
}

CString operator+ (const TCHAR chr, const CString& string2)
{
	return CString(chr, string2);
}

CString operator+ (const CString& string1, const TCHAR chr)
{
	return CString(string1, chr);
}

BOOL operator==(const CString& s1, const CString& s2)
{ 
	return s1.Equ(s2);
};

BOOL operator==(LPCTSTR s1, const CString& s2)
{ 
	return s2.Equ(s1);
};

BOOL operator==(const CString& s1, LPCTSTR s2)
{ 
	return s1.Equ(s2);
};

BOOL operator==(const CString& s1, const TCHAR chr)
{ 
	return s1.Equ(chr);
};

BOOL operator!=(const CString& s1, const CString& s2)
{ 
	return s1.NEqu(s2);
};

BOOL operator!=(LPCTSTR s1, const CString& s2)
{ 
	return s2.NEqu(s1);
};

BOOL operator!=(const CString& s1, LPCTSTR s2)
{ 
	return s1.NEqu(s2);
};

BOOL operator!=(const CString& s1, const TCHAR chr)
{ 
	return s1.NEqu(chr);
};


//////////////////////////////////////////////////////////////////////////////
// konverze sla INT na text

void CString::Int(int num)
{
// pprava bufferu
	TCHAR buf[15];
	TCHAR* dst = buf+15;
	int len = 0;

// pprava znamnka
	BOOL sign = FALSE;
	if (num < 0)
	{
		sign = TRUE;
		num = -num;
	}

// konverze slic
	do {
		dst--;
		*dst = (TCHAR)(((DWORD)num % 10) + '0');
		*(DWORD*)(&num) /= 10;
		len++;
	} while (num != 0);

// uloen znamnka
	if (sign)
	{
		dst--;
		*dst = '-';
		len++;
	}

// kopie do bufferu
	Detach();
	NewBuffer(len);
	MemCopy(pData->Data, dst, len*sizeof(TCHAR));
}

//////////////////////////////////////////////////////////////////////////////
// konverze textu na slo INT

int Int(LPCTSTR text)
{
// pprava promnnch
	DWORD result = 0;
	BOOL sign = FALSE;
	TCHAR chr;

// naten znamnka
	while (chr = *text)
	{
		if (chr == '-')
		{
			sign ^= TRUE;
		}
		else
		{
			if ((chr != '+') && (chr != ' ') && (chr != 9))
			{
				break;
			}
		}
		text++;
	}			
	
// naten slic
	while (chr = *text)
	{
		if ((chr >= '0') && (chr <= '9'))
		{
			if (result <= (DWORD)(0x7fffffff / 10))
			{
				result *= 10;
				result += (DWORD)(chr - '0');
			}
			else
			{
				result = 0x80000000;
			}

			if (result > 0x80000000)
			{
				result = 0x80000000;
			}
		}
		else
		{
			break;
		}
		text++;
	}

// nvrat s korekc znamnka
	if (sign)
	{
		return -(int)result;
	}

	if (result >= 0x80000000)
	{
		return 0x7fffffff;
	}

	return result;
}	


//////////////////////////////////////////////////////////////////////////////
// konverze sla DWORD na HEX (8 slic)

void CString::Hex(DWORD num)
{
// pprava bufferu
	Detach();
	NewBuffer(8);
	TCHAR* dst = pData->Data + 8;

// dekdovn slic
	TCHAR chr;
	for (int i = 8; i != 0; i--)
	{
		dst--;
		chr = (TCHAR)(num & 0xf);
		if (chr <= 9)
		{
			*dst = chr + '0';
		}
		else
		{
			*dst = chr - 10 + 'A';
		}

		num >>= 4;
	}
}

//////////////////////////////////////////////////////////////////////////////
// konverze sla DOUBLE na text

void CString::Double(double num)
{
// peteen "1#INF"
	if (*(ULONGLONG*)(&num) == DOUBLE_INFINITY_VALUE)
	{
		Detach();
		NewBuffer(5);
		pData->Data[0] = '1';
		pData->Data[1] = '#';
		pData->Data[2] = 'I';
		pData->Data[3] = 'N';
		pData->Data[4] = 'F';
		return;
	}

// dekdovn nuly
	if (num == 0)
	{
		Detach();
		NewBuffer(1);
		pData->Data[0] = '0';
		return;
	}

// pprava znamnka
	BOOL sign = FALSE;
	if (num < 0)
	{
		sign = TRUE;
		num = -num;
	}

// rozdlen sla na exponent a mantisu
	int expI = 0;
	double mantD = num;

	if (mantD >= 1)
	{
		if (mantD >= 1e256) { mantD *= 1e-256; expI += 256; };
		if (mantD >= 1e128) { mantD *= 1e-128; expI += 128; };
		if (mantD >= 1e64)  { mantD *= 1e-64;  expI += 64;  };
		if (mantD >= 1e32)  { mantD *= 1e-32;  expI += 32;  };
		if (mantD >= 1e16)  { mantD *= 1e-16;  expI += 16;  };
		if (mantD >= 1e8)   { mantD *= 1e-8;   expI += 8;   };
		if (mantD >= 1e4)   { mantD *= 1e-4;   expI += 4;   };
		if (mantD >= 1e2)   { mantD *= 1e-2;   expI += 2;   };
		if (mantD >= 1e1)   { mantD *= 1e-1;   expI += 1;   };
	}
	else
	{
		if (mantD < 1e-256) { mantD *= 1e257;  expI -= 257; };
		if (mantD < 1e-128) { mantD *= 1e129;  expI -= 129; };
		if (mantD < 1e-64)  { mantD *= 1e65;   expI -= 65;  };
		if (mantD < 1e-32)  { mantD *= 1e33;   expI -= 33;  };
		if (mantD < 1e-16)  { mantD *= 1e17;   expI -= 17;  };
		if (mantD < 1e-8)   { mantD *= 1e9;    expI -= 9;   };
		if (mantD < 1e-4)   { mantD *= 1e5;    expI -= 5;   };
		if (mantD < 1e-2)   { mantD *= 1e3;    expI -= 3;   };
		if (mantD < 1e-1)   { mantD *= 1e2;    expI -= 2;   };
		if (mantD < 1e0)    { mantD *= 1e1;    expI -= 1;   };
	}

	mantD *= 1e7;
	mantD += 6e-8;

	if (mantD >= 1e8)
	{
		mantD /= 10;
		expI++;
	}

	int mantH = (int)(mantD);
	int mantL = (int)((mantD - mantH)*1e7);

// dekdovn mantisy
	int i;
	TCHAR mantT[15];
	TCHAR* mantP = mantT+15;
	for (i = 7; i > 0; i--)
	{
		mantP--;
		*mantP = (TCHAR)((mantL % 10) + '0');
		mantL /= 10;
	}
	for (i = 8; i > 0; i--)
	{
		mantP--;
		*mantP = (TCHAR)((mantH % 10) + '0');
		mantH /= 10;
	}
	
// zjitn potu platnch slic
	TCHAR* dst = mantT+15;
	int digits = 15;
	for (; digits > 1; digits--)
	{
		dst--;
		if (*dst != '0') break;
	}

// pprava znamnka do vchozho bufferu
	TCHAR buf[30];
	dst = buf;
	if (sign)
	{
		*dst = '-';
		dst++;
	}

// dekdovn sla bez exponentu, slo >= 1
	if ((expI < 15) && (expI >= 0))
	{
		for (;;)
		{
			*dst = *mantP;
			dst++;
			mantP++;
			digits--;
			if ((expI <= 0) && (digits <= 0)) break;
			if (expI == 0)
			{
				*dst = '.';
				dst++;
			}
			expI--;
		}
	}
	else

// dekdovn sla bez exponentu, slo < 1
	if ((expI < 0) && (expI >= -3))
	{
		*dst = '0';
		dst++;
		*dst = '.';
		dst++;

		expI++;
		for (;expI < 0; expI++)
		{
			*dst = '0';
			dst++;
		}

		for (;digits > 0; digits--)
		{
			*dst = *mantP;
			dst++;
			mantP++;
		}
	}
	else

// dekdovn sla s exponentem
	{
		*dst = *mantP;
		dst++;
		mantP++;
		digits--;

		if (digits > 0)
		{
			*dst = '.';
			dst++;

			for (; digits > 0; digits--)
			{
				*dst = *mantP;
				dst++;
				mantP++;
			}
		}

		*dst = 'e';
		dst++;

		if (expI < 0)
		{
			*dst = '-';
			dst++;
			expI = -expI;
		}

		if (expI > 99)
		{
			*dst = (TCHAR)(expI/100) + '0';
			expI = expI % 100;
			dst++;

			*dst = (TCHAR)(expI/10) + '0';
			expI = expI % 10;
			dst++;
		}
		else
			if (expI > 9)
			{
				*dst = (TCHAR)(expI/10) + '0';
				expI = expI % 10;
				dst++;
			}

		*dst = (TCHAR)expI + '0';
		dst++;
	}

// uloen sla do bufferu
	int len = dst - buf;
	Detach();
	NewBuffer(len);
	MemCopy(pData->Data, buf, len*sizeof(TCHAR));
}

//////////////////////////////////////////////////////////////////////////////
// konverze textu na slo DOUBLE

double Double(LPCTSTR text)
{
// pprava promnnch
	double result = 0;			// vsledek
	double expN = 0;			// exponent
	double zlomek = 1;			// zlomek desetinn sti
	BOOL sign = FALSE;			// pznak zpornho znamnka
	BOOL signE = FALSE;			// znamnko exponentu
	TCHAR chr = *text;			// naten znak

// naten znamnka
	while (chr != 0)
	{
		if (chr == '-')
		{
			sign ^= TRUE;
		}
		else
		{
			if ((chr != '+') && (chr != ' ') && (chr != 9))
			{
				break;
			}
		}
		text++;
		chr = *text;
	}			
	
// naten slic cel sti
	while (chr != 0)
	{
		if ((chr >= '0') && (chr <= '9'))
		{
			result *= 10;
			result += chr - '0';
		}
		else
		{
			break;
		}
		text++;
		chr = *text;
	}

// naten slic desetinn sti
	if ((chr == '.') || (chr == ','))
	{
		text++;
		chr = *text;

		while (chr != 0)
		{
			if ((chr >= '0') && (chr <= '9'))
			{
				zlomek *= 10;
				result += (chr - '0')/zlomek;
			}
			else
			{
				break;
			}
			text++;
			chr = *text;
		}
	}

// vyputn mezer
	while ((chr == ' ') || (chr == 9))
	{
		text++;
		chr = *text;
	}

// test, zda je exponent
	if ((chr == 'E') || (chr == 'e'))
	{
		text++;
		chr = *text;

// vyputn mezer a uren znamnka
		while ((chr == ' ') || (chr == 9) || (chr == '+') || (chr == '-'))
		{
			if (chr == '-')
			{
				signE ^= TRUE;
			}
			text++;
			chr = *text;
		}

// naten slic exponentu
		while (chr != 0)
		{
			if ((chr >= '0') && (chr <= '9'))
			{
				expN *= 10;
				expN += chr - '0';
			}
			else
			{
				break;
			}
			text++;
			chr = *text;
		}

// vynsoben sla exponentem
		if (expN != 0)
		{
			if (signE)
			{
				expN = -expN;
			}
			result *= exp(expN*ln10);
		}
	}

// pznak peteen
	if (chr == '#')
	{
		if ((text[1] == 'I') &&
			(text[2] == 'N') &&
			(text[3] == 'F') &&
			((result == 1) || (result == 0)))
		{
			*(ULONGLONG*)(&result) = DOUBLE_INFINITY_VALUE;
			return result;
		}
	}

// nvrat s korekc znamnka
	if (sign)
	{
		return -result;
	}
	return result;
}	
